﻿Imports Infragistics.UltraChart.Core.Primitives

Public Class Form1

    Private dt As DataTable
    Private TextList As New List(Of Text)()


    Public Sub New()
        dt = New DataTable()
        dt.Columns.Add("A", GetType(Decimal))
        dt.Columns.Add("B", GetType(Decimal))
        dt.Columns.Add("C", GetType(Decimal))

        dt.Rows.Add(10, 20, 15)
        dt.Rows.Add(15, 10, 25)
        'dt.Rows.Add(30, 25, 10);

        InitializeComponent()
        UltraChart1.DataSource = dt
    End Sub


    Private Sub UltraChart1_FillSceneGraph(sender As System.Object, e As Infragistics.UltraChart.Shared.Events.FillSceneGraphEventArgs) Handles UltraChart1.FillSceneGraph
        TextList.Clear()
        Dim IsAddedKey As String = Nothing
        For Each pr As Primitive In e.SceneGraph
            If pr.Row <> -1 AndAlso pr.Column <> -1 AndAlso IsAddedKey <> (pr.Row.ToString() + "-" + pr.Column.ToString()) Then
                Dim tempPercent As Decimal = (Convert.ToDecimal(pr.Value) / CalcSum(dt.Rows(pr.Row))) * 100
                Dim textLable As New Text(New Point(CInt(DirectCast(pr, Infragistics.UltraChart.Core.Primitives.Path).GraphicsPath.PathPoints(0).X), CInt(DirectCast(pr, Infragistics.UltraChart.Core.Primitives.Path).GraphicsPath.PathPoints(0).Y)), tempPercent.ToString("0.00") + " %")
                textLable.PE.Fill = Color.Black
                IsAddedKey = pr.Row.ToString() + "-" + pr.Column.ToString()
                TextList.Add(textLable)
            End If
        Next
        For Each item As Text In TextList.Distinct()
            e.SceneGraph.Add(item)
        Next
    End Sub


    Private Function CalcSum(dr As DataRow) As Decimal
        Dim sum As Decimal = 0

        For Each item As Decimal In dr.ItemArray
            sum += item
        Next
        Return sum
    End Function
End Class
